<!DOCTYPE html>


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>Bérou &mdash; Bérou 0.1 documentation</title>
    
    <link rel="stylesheet" href="_static/basic.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="_static/bootstrap-3.3.4/css/bootstrap.min.css" type="text/css" />
    <link rel="stylesheet" href="_static/bootstrap-3.3.4/css/bootstrap-theme.min.css" type="text/css" />
    <link rel="stylesheet" href="_static/bootstrap-sphinx.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    './',
        VERSION:     '0.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/js/jquery-1.11.0.min.js"></script>
    <script type="text/javascript" src="_static/js/jquery-fix.js"></script>
    <script type="text/javascript" src="_static/bootstrap-3.3.4/js/bootstrap.min.js"></script>
    <script type="text/javascript" src="_static/bootstrap-sphinx.js"></script>
    <link rel="top" title="Bérou 0.1 documentation" href="#" />
<meta charset='utf-8'>
<meta http-equiv='X-UA-Compatible' content='IE=edge,chrome=1'>
<meta name='viewport' content='width=device-width, initial-scale=1.0, maximum-scale=1'>
<meta name="apple-mobile-web-app-capable" content="yes">

  </head>
  <body role="document">

  <div id="navbar" class="navbar navbar-default navbar-fixed-top">
    <div class="container">
      <div class="navbar-header">
        <!-- .btn-navbar is used as the toggle for collapsed navbar content -->
        <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".nav-collapse">
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
        </button>
        <a class="navbar-brand" href="#">
          Bérou</a>
        <span class="navbar-text navbar-version pull-left"><b>0.1</b></span>
      </div>

        <div class="collapse navbar-collapse nav-collapse">
          <ul class="nav navbar-nav">
            
            
              <li class="dropdown globaltoc-container">
  <a role="button"
     id="dLabelGlobalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Site <b class="caret"></b></a>
  <ul class="dropdown-menu globaltoc"
      role="menu"
      aria-labelledby="dLabelGlobalToc"></ul>
</li>
              
                <li class="dropdown">
  <a role="button"
     id="dLabelLocalToc"
     data-toggle="dropdown"
     data-target="#"
     href="#">Page <b class="caret"></b></a>
  <ul class="dropdown-menu localtoc"
      role="menu"
      aria-labelledby="dLabelLocalToc"><ul>
<li><a class="reference internal" href="#">Bérou</a><ul>
<li><a class="reference internal" href="#installation">Installation</a></li>
<li><a class="reference internal" href="#running-the-project">Running the project</a></li>
<li><a class="reference internal" href="#create-your-app">Create your app</a></li>
<li><a class="reference internal" href="#install-applications">Install applications</a></li>
<li><a class="reference internal" href="#the-berou-pypi-server">The Bérou pypi server</a></li>
<li><a class="reference internal" href="#how-to-upload-your-code-to-http-pypi-berou-fr">How to upload your code to http://pypi.berou.fr</a></li>
<li><a class="reference internal" href="#deploy-berou">Deploy Bérou</a><ul>
<li><a class="reference internal" href="#configure-nginx">Configure nginx</a></li>
<li><a class="reference internal" href="#configure-gunicorn-and-supervisor">Configure gunicorn and supervisor</a></li>
<li><a class="reference internal" href="#start-berou">Start Bérou</a></li>
</ul>
</li>
<li><a class="reference internal" href="#how-to-translate-my-app">How to translate my app ?</a><ul>
<li><a class="reference internal" href="#use-trans-in-templates">Use <cite>{% trans %}</cite> in templates</a></li>
<li><a class="reference internal" href="#use-ugettext-in-python-files">Use <cite>ugettext</cite> in python files</a></li>
<li><a class="reference internal" href="#run-makemessages-to-create-po-files">Run <cite>makemessages</cite> to create <cite>.po</cite> files</a></li>
</ul>
</li>
</ul>
</li>
</ul>
</ul>
</li>
              
            
            
              
                
              
            
            
            
            
              <li class="hidden-sm">
<div id="sourcelink">
  <a href="_sources/README.txt"
     rel="nofollow">Source</a>
</div></li>
            
          </ul>

          
            
<form class="navbar-form navbar-right" action="search.html" method="get">
 <div class="form-group">
  <input type="text" name="q" class="form-control" placeholder="Search" />
 </div>
  <input type="hidden" name="check_keywords" value="yes" />
  <input type="hidden" name="area" value="default" />
</form>
          
        </div>
    </div>
  </div>

<div class="container">
  <div class="row">
    <div class="col-md-12">
      
  <div class="section" id="berou">
<h1>Bérou<a class="headerlink" href="#berou" title="Permalink to this headline">¶</a></h1>
<p>Bérou is a platform that comes built-in with a repository
of applications ready to work on it.</p>
<div class="section" id="installation">
<h2>Installation<a class="headerlink" href="#installation" title="Permalink to this headline">¶</a></h2>
<div class="highlight-python"><div class="highlight"><pre># Get the source code
git clone git@gitlab.com:Pacodastre/Berou.git

# Create a virtualenv for the project
mkvirtualenv berou

# cd into the project
cd Berou

# Install dependencies using pip
pip install -r berou/requirements.txt

# cd into the django project
cd berou

# Create the database
./manage.py migrate
</pre></div>
</div>
<p>After installing the software, you might to create a superuser to access the admin interface.</p>
<div class="highlight-python"><div class="highlight"><pre>./manage.py createsuperuser
</pre></div>
</div>
</div>
<div class="section" id="running-the-project">
<h2>Running the project<a class="headerlink" href="#running-the-project" title="Permalink to this headline">¶</a></h2>
<p>Start the server with the following command:</p>
<div class="highlight-python"><div class="highlight"><pre>./manage.py runserver
</pre></div>
</div>
</div>
<div class="section" id="create-your-app">
<h2>Create your app<a class="headerlink" href="#create-your-app" title="Permalink to this headline">¶</a></h2>
<p>To create an app, just run this command:</p>
<div class="highlight-python"><div class="highlight"><pre>./manage.py startapp &lt;app name&gt;  # Replace &lt;app name&gt; with the actual name of your app
</pre></div>
</div>
<p>A Bérou application needs an extra file, for now, you can copy this template and modify the values.
Create a file called <cite>install.py</cite> in <cite>berou/&lt;app name&gt;</cite> with this content::</p>
<div class="highlight-python"><div class="highlight"><pre><span class="c"># -*- coding: utf-8 -*-</span>

<span class="kn">from</span> <span class="nn">django.utils.translation</span> <span class="kn">import</span> <span class="n">ugettext_lazy</span> <span class="k">as</span> <span class="n">_</span>
<span class="kn">from</span> <span class="nn">django.templatetags.static</span> <span class="kn">import</span> <span class="n">static</span>

<span class="kn">from</span> <span class="nn">application_system</span> <span class="kn">import</span> <span class="n">models</span>


<span class="k">def</span> <span class="nf">install</span><span class="p">():</span>
    <span class="n">app</span> <span class="o">=</span> <span class="n">models</span><span class="o">.</span><span class="n">App</span><span class="p">(</span>
        <span class="n">name</span><span class="o">=</span><span class="n">__package__</span><span class="o">.</span><span class="n">capitalize</span><span class="p">(),</span>
        <span class="n">description</span><span class="o">=</span><span class="n">_</span><span class="p">(</span><span class="s">&#39;Describe your app here&#39;</span><span class="p">),</span>
        <span class="n">slug</span><span class="o">=</span><span class="n">__package__</span><span class="p">,</span>
        <span class="n">logo</span><span class="o">=</span><span class="n">static</span><span class="p">(</span><span class="s">&#39;path to your logo&#39;</span><span class="p">),</span>  <span class="c"># if you don&#39;t have a logo, just remove this line</span>
    <span class="p">)</span>
    <span class="n">app</span><span class="o">.</span><span class="n">save</span><span class="p">()</span>
</pre></div>
</div>
<p>At the moment, all the apps are using <a class="reference external" href="https://docs.djangoproject.com/en/1.8/topics/class-based-views/">Django Class-Based Views</a>.</p>
<p>For a complete tutorial on how to create django apps, we invite you to read the <a class="reference external" href="https://docs.djangoproject.com/en/1.8/intro/tutorial01/">official tutorial</a>.</p>
<p><a class="reference external" href="http://ccbv.co.uk/">A good reference for Django Class-Based Views</a></p>
</div>
<div class="section" id="install-applications">
<h2>Install applications<a class="headerlink" href="#install-applications" title="Permalink to this headline">¶</a></h2>
<p>To install applications that you are developing, you simply need to run this command::</p>
<div class="highlight-python"><div class="highlight"><pre>./manage.py install_app &lt;app name&gt;
</pre></div>
</div>
<p>If you wish to install an app from the Bérou pypi project, you can install them like this::</p>
<div class="highlight-python"><div class="highlight"><pre>pip install &lt;app name&gt; --index-url=http://pypi.berou.fr
./manage.py install_app &lt;app name&gt;
</pre></div>
</div>
<p>That&#8217;s it!</p>
</div>
<div class="section" id="the-berou-pypi-server">
<h2>The Bérou pypi server<a class="headerlink" href="#the-berou-pypi-server" title="Permalink to this headline">¶</a></h2>
<p>A public instance of pypiserver is available here: <a class="reference external" href="http://pypi.berou.fr/">http://pypi.berou.fr/</a>
If you want to see all the available packages that you can install with the command above,
just go to: <a class="reference external" href="http://pypi.berou.fr/simple">http://pypi.berou.fr/simple</a></p>
</div>
<div class="section" id="how-to-upload-your-code-to-http-pypi-berou-fr">
<h2>How to upload your code to <a class="reference external" href="http://pypi.berou.fr">http://pypi.berou.fr</a><a class="headerlink" href="#how-to-upload-your-code-to-http-pypi-berou-fr" title="Permalink to this headline">¶</a></h2>
<p>TODO</p>
</div>
<div class="section" id="deploy-berou">
<h2>Deploy Bérou<a class="headerlink" href="#deploy-berou" title="Permalink to this headline">¶</a></h2>
<p>Bérou comes with configuration files for all the tools
you need to set up in order to Berou up and running in the clouds.</p>
<p>Here is the list of applications that Bérou needs:</p>
<ul class="simple">
<li>nginx: the web server. It will deliver the pages generated by Bérou to your users&#8217; browsers.</li>
<li><a class="reference external" href="http://gunicorn.org/">gunicorn</a>: a <a class="reference external" href="http://en.wikipedia.org/wiki/Web_Server_Gateway_Interface">wsgi</a> server.
It does the communication between nginx and Bérou.</li>
<li><a class="reference external" href="http://supervisord.org/">supervisor</a>: a Process Control System. It will allow you to easily start/stop Bérou.</li>
</ul>
<div class="section" id="configure-nginx">
<h3>Configure nginx<a class="headerlink" href="#configure-nginx" title="Permalink to this headline">¶</a></h3>
<p>Bérou comes with an nginx configuration file. You just need to fix the different paths.
The paths should be very closed to yours. When you&#8217;re done fixing the paths, the next thing
to do is to create a symlink in <cite>/etc/nginx/sites-available/</cite>,
and then make another symlink from the file in sites-available.
The symlink needs to be located in <cite>/etc/nginx/sites-enabled/</cite></p>
<p>The nginx configuration file in Bérou is located in <cite>Bérou/deployment/nginx/</cite>. Rename the file if needed.</p>
<div class="highlight-python"><div class="highlight"><pre># Assuming you&#39;re at the root of the Bérou project
ln -s deployment/nginx/berou.fr /etc/nginx/sites-available/
ln -s /etc/nginx/sites-available/ /etc/nginx/sites-enabled/
</pre></div>
</div>
<p><cite>sites-available</cite> is the folder that contains all sites served by nginx.
They are not necessarily activated and accessible. Only the ones contained in <cite>sites-enabled</cite> are activated.
If you wish to disable Bérou, just remove the file in <cite>sites-enabled</cite>.</p>
<p>When you&#8217;re done with the nginx configuration, reload its conf:</p>
<div class="highlight-python"><div class="highlight"><pre>service nginx reload
</pre></div>
</div>
</div>
<div class="section" id="configure-gunicorn-and-supervisor">
<h3>Configure gunicorn and supervisor<a class="headerlink" href="#configure-gunicorn-and-supervisor" title="Permalink to this headline">¶</a></h3>
<p>2 files needs to be edited with your settings.</p>
<p><cite>deployment/start_server.sh</cite> is a shell script that starts gunicorn. Fix the value of <cite>DJANGODIR</cite>.</p>
<p><cite>deployment/supervisor/supervisord.conf</cite> is the configuration file for supervisor.
You will to edit the following settings:</p>
<ul class="simple">
<li><cite>file</cite>, in the <cite>unix_http_server</cite> section. The path is likely to be wrong.
The <cite>run</cite> directory is located at the root of Bérou.</li>
<li><cite>logfile</cite>, in the <cite>supervisord</cite> section. The <cite>log</cite> directory is located at the root of Bérou.</li>
<li><cite>pidfile</cite>, in the <cite>supervisord</cite> section.</li>
<li><cite>serverurl</cite>, in the <cite>supervisorctl</cite> section. Note that it needs to match the <cite>file</cite> settings.</li>
<li><cite>directory</cite>, <cite>command</cite>, <cite>stdout_logfile</cite> in the <cite>program:berou</cite> section.</li>
</ul>
</div>
<div class="section" id="start-berou">
<h3>Start Bérou<a class="headerlink" href="#start-berou" title="Permalink to this headline">¶</a></h3>
<p>That&#8217;s it for the configuration. You can now start the server like this:</p>
<div class="highlight-python"><div class="highlight"><pre>supervisord -c deployment/supervisor/supervisord.conf
</pre></div>
</div>
<p>Now that supervisor has been started, you can send it commands:</p>
<div class="highlight-python"><div class="highlight"><pre>supervisorctl restart berou
supervisorctl stop berou
supervisorctl start berou
supervisorctl shutdown  # shutdowns supervisord
</pre></div>
</div>
</div>
</div>
<div class="section" id="how-to-translate-my-app">
<h2>How to translate my app ?<a class="headerlink" href="#how-to-translate-my-app" title="Permalink to this headline">¶</a></h2>
<p>In order to make your app available in different languages, you need to do a few things:</p>
<p>The first things you need to do is create a <cite>locale</cite> directory in your app folder.
When the directory is create, you will need to wrap all your strings with the <cite>ugettext</cite> function.</p>
<div class="section" id="use-trans-in-templates">
<h3>Use <cite>{% trans %}</cite> in templates<a class="headerlink" href="#use-trans-in-templates" title="Permalink to this headline">¶</a></h3>
<p>In order to use the ugettext function, you need to load the <cite>i18n</cite> module. Then, you need to use the
<cite>trans</cite> templatetag with your strings as parameters.</p>
<p>Exemple:</p>
<div class="highlight-python"><div class="highlight"><pre>{% extends &#39;berou/base.html&#39; %}
{% load i18n %}
{% trans &#39;Hello world!&#39; %}
{% block content %}
{% endblock content %}
</pre></div>
</div>
</div>
<div class="section" id="use-ugettext-in-python-files">
<h3>Use <cite>ugettext</cite> in python files<a class="headerlink" href="#use-ugettext-in-python-files" title="Permalink to this headline">¶</a></h3>
<p><cite>views.py</cite></p>
<div class="highlight-python"><div class="highlight"><pre><span class="kn">from</span> <span class="nn">django.utils.translation</span> <span class="kn">import</span> <span class="n">ugettext</span> <span class="k">as</span> <span class="n">_</span>
<span class="kn">from</span> <span class="nn">django.views.generic</span> <span class="kn">import</span> <span class="n">TemplateView</span>

<span class="k">class</span> <span class="nc">MyView</span><span class="p">(</span><span class="n">TemplateView</span><span class="p">):</span>
    <span class="n">template_name</span> <span class="o">=</span> <span class="s">&#39;my_app/my_template.html&#39;</span>

    <span class="k">def</span> <span class="nf">get_context_data</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="o">**</span><span class="n">kwargs</span><span class="p">):</span>
        <span class="n">context</span> <span class="o">=</span> <span class="nb">super</span><span class="p">(</span><span class="n">MyView</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="n">get_context_data</span><span class="p">(</span><span class="o">**</span><span class="n">kwargs</span><span class="p">)</span>
        <span class="n">context</span><span class="p">[</span><span class="s">&#39;my_text&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">_</span><span class="p">(</span><span class="s">&#39;Hello world!&#39;</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">context</span>
</pre></div>
</div>
</div>
<div class="section" id="run-makemessages-to-create-po-files">
<h3>Run <cite>makemessages</cite> to create <cite>.po</cite> files<a class="headerlink" href="#run-makemessages-to-create-po-files" title="Permalink to this headline">¶</a></h3>
<p>When you have at least one string wrapped in a <cite>ugettext</cite> call,
you can run <cite>makemessages</cite> to create a <cite>.po</cite> file.
<cite>makemessages</cite> needs a language code in order to create the right file.</p>
<p>This is how you run it:</p>
<div class="highlight-python"><div class="highlight"><pre>django-admin makemessages -l fr
</pre></div>
</div>
<p>Run this command in your app folder. <cite>fr</cite> is for the French language.
You can replace <cite>fr</cite> with any language that you can find on the
wikipedia page related called <a class="reference external" href="http://en.wikipedia.org/wiki/List_of_ISO_639-1_codes">List of ISO 639-1 codes</a></p>
<p>When running this command, Django searches in your application for translatable strings.
It will collect all of them and will write them in a <cite>.po</cite> file.
Empty strings will also be created for you to fill in with your translation.
The result in located in <cite>locale/fr/LC_MESSAGES/django.po</cite>.</p>
<p>When you&#8217;re done translating strings, you need to compile your translations:</p>
<div class="highlight-python"><div class="highlight"><pre>./manage.py compilemessages
</pre></div>
</div>
<p>That&#8217;s it, your application is now translated.
If a french user accesses Bérou, they will get the text in French.
If HTTP requests have the <cite>accept-language</cite> header, django will use its value
in order to determine which language to use.
There is an article published on <a class="reference external" href="http://www.w3.org/International/questions/qa-accept-lang-locales">w3</a>.</p>
</div>
</div>
</div>


    </div>
      
  </div>
</div>
<footer class="footer">
  <div class="container">
    <p class="pull-right">
      <a href="#">Back to top</a>
      
    </p>
    <p>
        &copy; Copyright 2015, Francois Ribemont.<br/>
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.3.1.<br/>
    </p>
  </div>
</footer>
  </body>
</html>